/*
 * noVNC: HTML5 VNC client
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * See README.md for usage and integration instructions.
 */
function Display(e){"use strict";function t(){Util.Debug(">> Display.constructor");var e,t,a,o,r=Util.Engine;if(!l.target)throw"target must be set";if("string"==typeof l.target)throw"target must be a DOM element";if(e=l.target,!e.getContext)throw"no getContext method";if(u||(u=e.getContext("2d")),Util.Debug("User Agent: "+navigator.userAgent),r.gecko&&Util.Debug("Browser: gecko "+r.gecko),r.webkit&&Util.Debug("Browser: webkit "+r.webkit),r.trident&&Util.Debug("Browser: trident "+r.trident),r.presto&&Util.Debug("Browser: presto "+r.presto),n.clear(),!("createImageData"in u))throw"Canvas does not support createImageData";for(l.render_mode="canvas rendering",null===l.prefer_js&&(Util.Info("Prefering javascript operations"),l.prefer_js=!0),g=u.createImageData(16,16),a=[],t=0;256>t;t+=1)a.push(255);try{o=e.style.cursor,changeCursor(l.target,a,a,2,2,8,8),e.style.cursor?(null===l.cursor_uri&&(l.cursor_uri=!0),Util.Info("Data URI scheme cursor supported")):(null===l.cursor_uri&&(l.cursor_uri=!1),Util.Warn("Data URI scheme cursor not supported")),e.style.cursor=o}catch(s){Util.Error("Data URI scheme cursor test exception: "+s),l.cursor_uri=!1}return Util.Debug("<< Display.constructor"),n}var a,o,r,s,i,n={},l={},u=null,d=0,c=0,p={x:0,y:0,w:0,h:0},m={x1:0,y1:0,x2:-1,y2:-1},h="",f=null,g=null,v=0,b=0;return Util.conf_defaults(l,n,e,[["target","wo","dom",null,"Canvas element for rendering"],["context","ro","raw",null,"Canvas 2D context for rendering (read-only)"],["logo","rw","raw",null,'Logo to display when cleared: {"width": width, "height": height, "data": data}'],["true_color","rw","bool",!0,"Use true-color pixel data"],["colourMap","rw","arr",[],"Colour map array (when not true-color)"],["scale","rw","float",1,"Display area scale factor 0.0 - 1.0"],["viewport","rw","bool",!1,"Use a viewport set with viewportChange()"],["width","rw","int",null,"Display area width"],["height","rw","int",null,"Display area height"],["render_mode","ro","str","","Canvas rendering mode (read-only)"],["prefer_js","rw","str",null,"Prefer Javascript over canvas methods"],["cursor_uri","rw","raw",null,"Can we render cursor using data URI"]]),n.get_context=function(){return u},n.set_scale=function(e){i(e)},n.set_width=function(e){n.resize(e,c)},n.get_width=function(){return d},n.set_height=function(e){n.resize(d,e)},n.get_height=function(){return c},i=function(e){var t,a,o,r,s=["transform","WebkitTransform","MozTransform",null];for(t=l.target,a=s.shift();a&&"undefined"==typeof t.style[a];)a=s.shift();return null===a?void Util.Debug("No scaling support"):("undefined"==typeof e?e=l.scale:e>1?e=1:.1>e&&(e=.1),void(l.scale!==e&&(l.scale=e,o=t.width-t.width*e,r=t.height-t.height*e,t.style[a]="scale("+l.scale+") translate(-"+o+"px, -"+r+"px)")))},s=function(e){var t,a;t=l.true_color?e:l.colourMap[e[0]],a="rgb("+t[2]+","+t[1]+","+t[0]+")",a!==h&&(u.fillStyle=a,h=a)},n.viewportChange=function(e,t,a,o){var r,s,i,n,h,f,g,v=l.target,b=p,y=m,w=null;l.viewport||(Util.Debug("Setting viewport to full display region"),e=-b.w,t=-b.h,a=d,o=c),"undefined"==typeof e&&(e=0),"undefined"==typeof t&&(t=0),"undefined"==typeof a&&(a=b.w),"undefined"==typeof o&&(o=b.h),a>d&&(a=d),o>c&&(o=c),(b.w!==a||b.h!==o)&&(a<b.w&&y.x2>b.x+a-1&&(y.x2=b.x+a-1),b.w=a,o<b.h&&y.y2>b.y+o-1&&(y.y2=b.y+o-1),b.h=o,b.w>0&&b.h>0&&v.width>0&&v.height>0&&(w=u.getImageData(0,0,v.width<b.w?v.width:b.w,v.height<b.h?v.height:b.h)),v.width=b.w,v.height=b.h,w&&u.putImageData(w,0,0)),n=b.x+b.w-1,h=b.y+b.h-1,0>e&&b.x+e<0&&(e=-b.x),n+e>=d&&(e-=n+e-d+1),b.y+t<0&&(t=-b.y),h+t>=c&&(t-=h+t-c+1),(0!==e||0!==t)&&(Util.Debug("viewportChange deltaX: "+e+", deltaY: "+t),b.x+=e,n+=e,b.y+=t,h+=t,b.x>y.x1&&(y.x1=b.x),n<y.x2&&(y.x2=n),b.y>y.y1&&(y.y1=b.y),h<y.y2&&(y.y2=h),0>e?(s=0,f=-e):(s=b.w-e,f=e),0>t?(i=0,g=-t):(i=b.h-t,g=t),r=u.fillStyle,u.fillStyle="rgb(255,255,255)",0!==e&&(u.drawImage(v,0,0,b.w,b.h,-e,0,b.w,b.h),u.fillRect(s,0,f,b.h)),0!==t&&(u.drawImage(v,0,0,b.w,b.h,0,-t,b.w,b.h),u.fillRect(0,i,b.w,g)),u.fillStyle=r)},n.getCleanDirtyReset=function(){var e,t=p,a=m,o=[],r=t.x+t.w-1,s=t.y+t.h-1;return e={x:a.x1,y:a.y1,w:a.x2-a.x1+1,h:a.y2-a.y1+1},a.x1>=a.x2||a.y1>=a.y2?o.push({x:t.x,y:t.y,w:t.w,h:t.h}):(t.x<a.x1&&o.push({x:t.x,y:t.y,w:a.x1-t.x+1,h:t.h}),r>a.x2&&o.push({x:a.x2+1,y:t.y,w:r-a.x2,h:t.h}),t.y<a.y1&&o.push({x:a.x1,y:t.y,w:a.x2-a.x1+1,h:a.y1-t.y}),s>a.y2&&o.push({x:a.x1,y:a.y2+1,w:a.x2-a.x1+1,h:s-a.y2})),m={x1:t.x,y1:t.y,x2:t.x+t.w-1,y2:t.y+t.h-1},{cleanBox:e,dirtyBoxes:o}},n.absX=function(e){return e+p.x},n.absY=function(e){return e+p.y},n.resize=function(e,t){h="",d=e,c=t,i(l.scale),n.viewportChange()},n.clear=function(){l.logo?(n.resize(l.logo.width,l.logo.height),n.blitStringImage(l.logo.data,0,0)):(n.resize(640,20),u.clearRect(0,0,p.w,p.h))},n.fillRect=function(e,t,a,o,r){s(r),u.fillRect(e-p.x,t-p.y,a,o)},n.copyImage=function(e,t,a,o,r,s){var i=e-p.x,n=t-p.y,d=a-p.x,c=o-p.y;u.drawImage(l.target,i,n,r,s,d,c,r,s)},n.startTile=function(e,t,a,o,r){var s,i,d,c,p,m;if(v=e,b=t,f=16===a&&16===o?g:u.createImageData(a,o),s=f.data,l.prefer_js)for(i=l.true_color?r:l.colourMap[r[0]],d=i[2],c=i[1],p=i[0],m=0;a*o*4>m;m+=4)s[m]=d,s[m+1]=c,s[m+2]=p,s[m+3]=255;else n.fillRect(e,t,a,o,r)},n.subTile=function(e,t,a,o,r){var s,i,u,d,c,p,m,h,g,y,w;if(l.prefer_js)for(s=f.data,m=f.width,u=l.true_color?r:l.colourMap[r[0]],d=u[2],c=u[1],p=u[0],y=e+a,w=t+o,h=t;w>h;h+=1)for(g=e;y>g;g+=1)i=4*(g+h*m),s[i]=d,s[i+1]=c,s[i+2]=p,s[i+3]=255;else n.fillRect(v+e,b+t,a,o,r)},n.finishTile=function(){l.prefer_js&&u.putImageData(f,v-p.x,b-p.y)},a=function(e,t,a,o,r,s){var i,n,l,d,c=p;for(i=u.createImageData(a,o),d=i.data,n=0,l=s;a*o*4>n;n+=4,l+=3)d[n]=r[l],d[n+1]=r[l+1],d[n+2]=r[l+2],d[n+3]=255;u.putImageData(i,e-c.x,t-c.y)},o=function(e,t,a,o,r,s){var i,n,l,d,c=p;for(i=u.createImageData(a,o),d=i.data,n=0,l=s;a*o*4>n;n+=4,l+=4)d[n]=r[l+2],d[n+1]=r[l+1],d[n+2]=r[l],d[n+3]=255;u.putImageData(i,e-c.x,t-c.y)},r=function(e,t,a,o,r,s){var i,n,d,c,m,h;for(i=u.createImageData(a,o),c=i.data,h=l.colourMap,n=0,d=s;a*o*4>n;n+=4,d+=1)m=h[r[d]],c[n]=m[2],c[n+1]=m[1],c[n+2]=m[0],c[n+3]=255;u.putImageData(i,e-p.x,t-p.y)},n.blitImage=function(e,t,a,s,i,n){l.true_color?o(e,t,a,s,i,n):r(e,t,a,s,i,n)},n.blitRgbImage=function(e,t,o,s,i,n){l.true_color?a(e,t,o,s,i,n):r(e,t,o,s,i,n)},n.blitStringImage=function(e,t,a){var o=new Image;o.onload=function(){u.drawImage(o,t-p.x,a-p.y)},o.src=e},n.changeCursor=function(e,t,a,o,r,s){return l.cursor_uri===!1?void Util.Warn("changeCursor called but no cursor data URI support"):void(l.true_color?changeCursor(l.target,e,t,a,o,r,s):changeCursor(l.target,e,t,a,o,r,s,l.colourMap))},n.defaultCursor=function(){l.target.style.cursor="default"},t()}function changeCursor(e,t,a,o,r,s,i,n){"use strict";var l,u,d,c,p,m,h,f,g,v,b=[];for(b.push16le=function(e){this.push(255&e,e>>8&255)},b.push32le=function(e){this.push(255&e,e>>8&255,e>>16&255,e>>24&255)},u=40,d=s*i*4,p=Math.ceil(s*i/8),c=Math.ceil(s*i/8),b.push16le(0),b.push16le(2),b.push16le(1),b.push(s),b.push(i),b.push(0),b.push(0),b.push16le(o),b.push16le(r),b.push32le(u+d+p+c),b.push32le(22),b.push32le(u),b.push32le(s),b.push32le(2*i),b.push16le(1),b.push16le(32),b.push32le(0),b.push32le(p+c),b.push32le(0),b.push32le(0),b.push32le(0),b.push32le(0),v=i-1;v>=0;v-=1)for(g=0;s>g;g+=1)h=v*Math.ceil(s/8)+Math.floor(g/8),f=a[h]<<g%8&128?255:0,n?(h=s*v+g,l=n[t[h]],b.push(l[2]),b.push(l[1]),b.push(l[0]),b.push(f)):(h=4*(s*v+g),b.push(t[h+2]),b.push(t[h+1]),b.push(t[h]),b.push(f));for(v=0;i>v;v+=1)for(g=0;g<Math.ceil(s/8);g+=1)b.push(0);for(v=0;i>v;v+=1)for(g=0;g<Math.ceil(s/8);g+=1)b.push(0);m="data:image/x-icon;base64,"+Base64.encode(b),e.style.cursor="url("+m+") "+o+" "+r+", default"}